﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace aboose
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void _load_Click(object sender, EventArgs e)
        {
            //#     27 "Eastern Analogue"  [U:1:57639658]       1:28:50   175    0 active
            // Starts with #
            // one or more spaces
            // one or more digits
            // ONE space
            // quote
            // any number of any characters
            // quote
            // one or more spaces
            // [U:
            // any number of characters that are not ]
            // one or more spaces
            // at least one digit
            // no occurences of ] until end of line
            Regex r = new Regex("^# +[0-9]+ \".*\" +\\[(U:[^\\]]*)\\] +[0-9][^\\]]*$");
            string[] lines = Clipboard.GetText().Replace("\r\n", "\n").Split('\n');
            string targets = "";
            foreach (string line in lines)
            {
                Match m = r.Match(line);
                if (m.Groups.Count > 1)
                    targets += m.Groups[1].Value + " ";
            }
            _targets.Text = targets;
        }

        private void _targets_TextChanged(object sender, EventArgs e)
        {
            _targets.Text = _targets.Text.Trim();
            label1.Text = "List of abuse targets (" + _targets.Text.Split(' ').Length + ")";
        }

        private void _abuse_Click(object sender, EventArgs e)
        {
            string[] targets = _targets.Text.Split(' ');
            int limit = Convert.ToInt32(_limit.Text);
            int until = limit;
            string output = "";
            bool append_semicolon = false;
            foreach (string target in targets)
            {
                if (--until < 0)
                {
                    append_semicolon = false;
                    output += "\r\n\r\n";
                    until = limit - 1;
                }
                if (append_semicolon)
                    output += ";";

                output += _commands.Text.Replace(_key.Text, target).Replace("\r\n", ";");
                append_semicolon = true;
            }
            if (_clip.Checked)
            {
                Clipboard.Clear();
                Clipboard.SetText(output);
            }
            if (_msg.Checked)
                MessageBox.Show(output);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                _commands.Text = System.IO.File.ReadAllText("aboose.txt", Encoding.UTF8);
            }
            catch { }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.IO.File.WriteAllText("aboose.txt", _commands.Text, Encoding.UTF8);
        }
    }
}
